 
function cn_unplugset_populate(){
   cn_unplugset_filllist(false);
   
   if (window && window.arguments && window.arguments.length > 0){
      if (window.arguments[0] == "PROG") {
         var xx = document.getElementById("cxxTabPans");
         if (xx) xx.selectedIndex=2;
      }
   }
   
   var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
   iconfeatures_onoff(prefs.getBoolPref("extensions.cn_unplug.prog_global"));
}

function cn_unplugset_save(){
   cn_unplugset_filllist(true);
}

function cn_unplugset_filllist(save){
   try {
      var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
      
      cn_unplugset_fillbool("cxLink", "search_links", prefs, save);
      cn_unplugset_fillbool("cxHelpIcon", "show_help", prefs, save);
      cn_unplugset_fillbool("cxDownPlay", "get_playlists", prefs, save);
      cn_unplugset_fillint("cxMenuShow", "pagehog_when", prefs, save);
      cn_unplugset_fillint("cxMenuWait", "pagehog_timeout", prefs, save);
      cn_unplugset_fillbool("cxShowIcon", "show_cnicon", prefs, save);
      cn_unplugset_fillbool("cxBiggerText", "bigger_text", prefs, save);
      cn_unplugset_fillint("cxResWindow", "results_window", prefs, save);
      cn_unplugset_fillbool("cxDev", "developer", prefs, save);
      cn_unplugset_fillint("cxDownloadTimeout", "download_timeout", prefs, save);
      cn_unplugset_fillbool("cxMenuContext", "menu_context", prefs, save);
      cn_unplugset_fillbool("cxNoMediaAlert", "nomedia_alert", prefs, save);
      
      cn_unplugset_fillbool("cxKeepVid", "use_keepvid", prefs, save);
      cn_unplugset_fillbool("cxKeepVidAlways", "use_keepvid_always", prefs, save);
      cn_unplugset_fillbool("cxVideoDownloader", "use_videodownloader", prefs, save);
      cn_unplugset_fillbool("cxVideoDownloaderAlways", "use_videodownloader_always", prefs, save);
      
      cn_unplugset_fillbool("cxProgGlob", "prog_global", prefs, save);
      cn_unplugset_fillbool("cxPAL_vlc", "prog_allow_vlc", prefs, save);
      cn_unplugset_fillstr("cxPLO_vlc", "prog_lo_vlc", prefs, save);
      cn_unplugset_fillbool("cxPAL_media", "prog_allow_media", prefs, save);
      cn_unplugset_fillstr("cxPLO_media", "prog_lo_media", prefs, save);
      cn_unplugset_fillbool("cxPAL_helix", "prog_allow_helix", prefs, save);
      cn_unplugset_fillstr("cxPLO_helix", "prog_lo_helix", prefs, save);
      cn_unplugset_fillbool("cxPAL_dta", "prog_allow_dta", prefs, save);
      cn_unplugset_fillbool("cxPAL_fxsave", "prog_allow_fxsave", prefs, save);
      cn_unplugset_fillbool("cxOverDta", "prog_allow_over_dta", prefs, save);
      
      cn_unplugset_fillbool("cxFlashBlock", "use_flashblock", prefs, save);
      
      var gBundle = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService);
      var unplugstrings = gBundle.createBundle("chrome://unplug/locale/unplug.properties");
      document.getElementById("trans").value = unplugstrings.GetStringFromName("Translated_By");

   } catch(e) {
      alert("There is a probelm with loading or saving these options.\n\nPlease report this error.");
      window.close();
   }
}

function cn_unplugset_fillbool(elid, prid, prefs, save){
   var it = document.getElementById(elid);
   if (!it) {
      alert(eid+" not found");
      return;
   }
   if (save)
      prefs.setBoolPref("extensions.cn_unplug." + prid, it.checked);
   else
      it.setAttribute("checked", prefs.getBoolPref("extensions.cn_unplug." + prid));
}

function cn_unplugset_fillint(elid, prid, prefs, save){
   var it = document.getElementById(elid);
   if (!it) {
      alert(eid+" not found");
      return;
   }
   if (save)
      prefs.setIntPref("extensions.cn_unplug." + prid, it.value);
   else
      it.value = prefs.getIntPref("extensions.cn_unplug." + prid);
}

function cn_unplugset_fillstr(elid, prid, prefs, save){
   var it = document.getElementById(elid);
   if (!it) {
      alert(eid+" not found");
      return;
   }
   if (save)
      prefs.setCharPref("extensions.cn_unplug." + prid, it.value);
   else
      it.value = prefs.getCharPref("extensions.cn_unplug." + prid);
}

function fpgo(elem){
   try{
      var nsIFilePicker = Components.interfaces.nsIFilePicker;
      var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
      fp.appendFilters(nsIFilePicker.filterApps);
      fp.defaultString = document.getElementById(elem).value;
      fp.init(window, "Select a File", nsIFilePicker.modeOpen);
      var res = fp.show();
      if (res == nsIFilePicker.returnOK){
         var f = fp.file;
         u = f.path;
         if (u.indexOf("://") >= 0) throw u + " is a URL, but a local file reference is required.";
         document.getElementById(elem).value = u;
      }
   } catch(e) {
      alert("Unplug Error / fpgo\n" + e);
   }
}

function iconfeatures_onoff(allow){
   var l = document.getElementById("alliconfeatures");
   for (var i in l.childNodes){
      var el = l.childNodes[i];
      el.disabled = !allow;
      for (var j in el.childNodes){
         var el2 = el.childNodes[j];
         el2.disabled = !allow;
      }
   }
}
